/******************************************************************
**	  107壨V1.0
**	  USARTļ
**
**	      ̳bbs.openmcu.com
**	      www.openmcu.com
**	      䣺support@openmcu.com
**
**        V1.1
**	      ߣopenmcu
**	  :	2014.3.20
********************************************************************/
#include "usart.h"
#include "stm32f10x.h"



/*********************************************************************************************************
** Functoin name:       Init_Usart
** Descriptions:        ʼUSart
						ʱӡIOUSARTʽжáDMA
** input paraments:       
** output paraments:        
** Returned values:     
*********************************************************************************************************/				   
void Init_Usart(void)
{  /*ڳʼ*/
	
	GPIO_InitTypeDef GPIO_InitStruct;
	USART_InitTypeDef USART_InitStruct;
	NVIC_InitTypeDef NVIC_InitStruct;

#if !defined (USE_USART1)  && !defined (USE_USART2) || (((defined USE_USART2)&&(defined USE_USART1)))
	#error:"Please select USARTx (in file usart.h)"
#endif

#ifdef	USE_USART1
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA | RCC_APB2Periph_USART1
												| RCC_APB2Periph_AFIO,ENABLE);
#endif
#ifdef USE_USART2 
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOD| RCC_APB2Periph_AFIO,ENABLE);
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART2,ENABLE);
	GPIO_PinRemapConfig(GPIO_Remap_USART2,ENABLE);
#endif
	
	//ڵIOʼ
	GPIO_InitStruct.GPIO_Pin = Pin_Tx;
	GPIO_InitStruct.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStruct.GPIO_Mode = GPIO_Mode_AF_PP;	
	GPIO_Init(USART_Port,&GPIO_InitStruct); //TX	

	GPIO_InitStruct.GPIO_Pin = Pin_Rx;
	GPIO_InitStruct.GPIO_Mode = GPIO_Mode_IN_FLOATING;	
	GPIO_Init(USART_Port,&GPIO_InitStruct); //RX	

	//ڳʼ
	USART_InitStruct.USART_BaudRate  = BaudRate;
	USART_InitStruct.USART_WordLength  = WordLength;
	USART_InitStruct.USART_StopBits  = StopBits;
	USART_InitStruct.USART_Parity  = Parity ;
	USART_InitStruct.USART_Mode  = Mode;
	USART_InitStruct.USART_HardwareFlowControl  = HardwareFlowControl;
	USART_Init(USART,&USART_InitStruct);

	//ʹܽж
	USART_ITConfig(USART,USART_IT_RXNE,ENABLE);

	NVIC_InitStruct.NVIC_IRQChannel = USART_IRQn;
	NVIC_InitStruct.NVIC_IRQChannelPreemptionPriority = 1;
	NVIC_InitStruct.NVIC_IRQChannelSubPriority = 2;
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStruct);

	USART_Cmd(USART,ENABLE);
}

/*********************************************************************************************************
** Functoin name:       Usart_SendChar
** Descriptions:        USARTһַ
** input paraments:     USARTxõĴں
						datҪ͵
** output paraments:        
** Returned values:     
*********************************************************************************************************/
void Usart_SendChar(USART_TypeDef* USARTx,char dat)
{
	while(!USART_GetFlagStatus(USARTx,USART_FLAG_TXE));	
	USART_SendData(USARTx,dat);

}

/*********************************************************************************************************
** Functoin name:       Usart_GetCahr
** Descriptions:        USARTһַ
** input paraments:     USARTxõĴں
** output paraments:        
** Returned values:     dat:յ
*********************************************************************************************************/
char Usart_GetCahr(USART_TypeDef* USARTx)
{
	char dat;
	while(!USART_GetFlagStatus(USARTx,USART_FLAG_RXNE));
	dat = (char)(USART_ReceiveData(USARTx)&0xff);
	
	return dat;		
}

/*********************************************************************************************************
** Functoin name:       USART1_IRQHandler
** Descriptions:        USART1жϴ
** input paraments:     
** output paraments:        
** Returned values:     
*********************************************************************************************************/
void USART_IRQHandler(void)
{
	if(USART_GetFlagStatus(USART,USART_FLAG_RXNE))
	{
		Usart_SendChar(USART,USART_ReceiveData(USART));	
	}
	if(USART_GetFlagStatus(USART,USART_FLAG_TXE))
	{
		USART_ClearFlag(USART,USART_FLAG_TC);	
	}	
}


/*********************************************************************************************************
** Functoin name:       fputc
** Descriptions:        ⺯printfӿ
** input paraments:     DATA/f:ϲ㺯
** output paraments:        
** Returned values:     Data:͵
*********************************************************************************************************/
#pragma import(__use_no_semihosting)
//׼Ҫֺ֧                 
struct __FILE 
{ 
	int handle; 
	/* Whatever you require here. If the only file you are using is */ 
	/* standard output using printf() for debugging, no file handling */ 
	/* is required. */ 
}; 
/* FILE is typedef d in stdio.h. */ 
FILE __stdout;       
//_sys_exit()Աʹðģʽ    
_sys_exit(int x) 
{ 
	x = x; 
} 
int fputc(int Data, FILE *f)
{   
	while(!USART_GetFlagStatus(USART,USART_FLAG_TXE));	  //USART_GetFlagStatusõ״̬λ
														  //USART_FLAG_TXE:ͼĴΪ 1Ϊգ0æ״̬
	USART_SendData(USART,Data);						  //һַ
	   
	return Data;										  //һֵ
}
/*********************************************************************************************************
**                                        End Of File
*********************************************************************************************************/
